import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import javax.tools.Diagnostic;
import javax.tools.DiagnosticCollector;
import javax.tools.JavaCompilerTool;
import javax.tools.JavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import javax.tools.JavaCompilerTool.CompilationTask;

public class DiagnosticDemo {

    public static void main(String[] args) {
        // specify the source code, change accordingly
        String sourceFile = "c:/temp/HelloWorld.java";
        JavaCompilerTool compiler = 
                ToolProvider.getSystemJavaCompilerTool();
        DiagnosticCollector<JavaFileObject> diagnostics =
                new DiagnosticCollector<JavaFileObject>();
        // get the standard JavaFileManager implementation 
        // for this tool, passing a DiagnosticCollector 
        StandardJavaFileManager fileManager = 
                compiler.getStandardFileManager(diagnostics);

        // prepare the source file(s) to compile
        List<File> sourceFileList = new ArrayList<File>();
        sourceFileList.add(new File(sourceFile));
        Iterable<? extends JavaFileObject> compilationUnits =
                fileManager.getJavaFileObjectsFromFiles(
                sourceFileList);
        CompilationTask task = compiler.getTask(null, 
                fileManager, null, null, null, compilationUnits);
        task.run();
        // our task is completed, now close the file manager
        try {
            fileManager.close();
        } catch (IOException e) {
        }
        // let's see what's in diagnostics
        List<Diagnostic<? extends JavaFileObject>> 
                diagnosticList = diagnostics.getDiagnostics();
        // iterate diagnosticList
        for (Diagnostic<? extends JavaFileObject> diagnostic : 
                diagnosticList) {
            // now you can use diagnostic, such as in
            System.out.println("Position:" +
                    diagnostic.getStartPosition());
        }

    }
}
